package gonganxitong

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/ctx"
	"shylinux.com/x/icebergs/base/web/html"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/gonganxitong/model"
)

type Message struct {
	Table
	order  string `data:"100"`
	domain string `data:"gonganxitong"`
	read   string `name:"read" role:"void"`
	done   string `name:"done" role:"void"`
}

func (s Message) Create(m *ice.Message, arg ...string) {
	s.Table.Create(m, kit.Simple(arg)...)
}
func (s Message) List(m *ice.Message, arg ...string) {
	if len(arg) < 2 {
		s.Select(m, model.TO_USER_UID, m.Option(model.USER_UID))
	} else if len(arg) == 2 {
		msg := s.SelectDetail(m.Spawn(), model.TO_USER_UID, m.Option(model.USER_UID), model.UID, arg[1])
		m.ProcessField(msg.Append(ctx.INDEX), kit.Split(msg.Append(ctx.ARGS)))
		m.Push(ctx.STYLE, html.OUTPUT)
		m.Option("field.option", kit.Format(kit.Dict(model.MESSAGE_UID, arg[1])))
		if m.Option(model.MESSAGE_STATUS) == MessageCreate.String() {
			s.Update(m, kit.Dict(model.STATUS, MessageRead), kit.Simple(model.TO_USER_UID, m.Option(model.USER_UID), model.UID, arg[1], model.STATUS, MessageCreate)...)
		}
	} else {
		return
	}
	m.Table(func(value ice.Maps) {
		switch MessageStatus(kit.Int(value[model.STATUS])) {
		case MessageCreate:
			m.PushButton(s.Read, s.Done)
		case MessageRead:
			m.PushButton(s.Done)
		default:
			m.PushButton()
		}
	}).Action()
	m.RenameAppend(model.FROM_USER_UID, model.USER_UID, model.STATUS, model.MESSAGE_STATUS)
	s.SelectJoinUser(m)
}
func (s Message) Read(m *ice.Message, arg ...string) {
	s.Table.Update(m, kit.Dict(model.STATUS, MessageRead), kit.Simple(model.TO_USER_UID, m.Option(model.USER_UID), m.OptionSimple(model.UID), model.STATUS, MessageCreate)...)
}
func (s Message) Done(m *ice.Message, arg ...string) {
	s.Table.Update(m, kit.Dict(model.STATUS, MessageDone), kit.Simple(model.TO_USER_UID, m.Option(model.USER_UID), m.OptionSimple(model.UID), model.STATUS, MessageRead)...)
}

type message struct{ Message }

func init() { ice.TeamCtxCmd(message{}) }

type MessageStatus int

const (
	MessageCreate MessageStatus = iota
	MessageRead
	MessageDone
)

var MessageStatusList = map[MessageStatus]string{
	MessageCreate: "create",
	MessageRead:   "read",
	MessageDone:   "done",
}

func (s MessageStatus) String() string { return MessageStatusList[s] }
